#ifndef SAGA_IMPL_PACKAGES_ISN_ENTITY_DATA_HPP
#define SAGA_IMPL_PACKAGES_ISN_ENTITY_DATA_HPP

#include <saga/impl/config.hpp>
#include <saga/impl/engine/attribute.hpp>
#include <saga/impl/engine/object.hpp>

///////////////////////////////////////////////////////////////////////////////
namespace saga
{
  namespace impl
  {
    // Entity Data implementation
    class entity_data
      : public saga::impl::object,
        public saga::impl::attribute
    {
      typedef saga::impl::attribute attribute_base;

      explicit entity_data(attribute const& attr);
      public:

      /**
       * Constructor of entity_data
       */
      entity_data ();
      ~entity_data ();
      saga::impl::attribute* get_attributes() { return this; }
      saga::impl::attribute const* get_attributes() const { return this; }

      // Generate an exact deep copy of this object
      saga::object clone() const;
    };

  } // namespace impl

} // namespace saga

#endif // !defined(SAGA_IMPL_PACKAGES_ISN_ENTITY_DATA_HPP)

