#ifndef SAGA_PACKAGES_ISN_ENTITY_DATA_SET_HPP
#define SAGA_PACKAGES_ISN_ENTITY_DATA_SET_HPP

#include <string>
#include <map>
#include <vector>
#include <iostream>

#include <saga/saga/util.hpp>
#include <saga/saga/base.hpp>
#include <saga/saga/types.hpp>
#include <saga/saga/call.hpp>
#include <saga/saga/detail/attribute.hpp>
#include <saga/saga/packages/isn/config.hpp>

#include "entity_data.hpp"

namespace saga { namespace impl { class entity_data_set; } }

namespace saga
{
   namespace isn {

class SAGA_ISN_PACKAGE_EXPORT entity_data_set
   : public saga::object
{
   protected:
      friend class saga::impl::entity_data_set;

      explicit entity_data_set(saga::impl::entity_data_set* impl);

      saga::impl::entity_data_set* get_impl(void) const;

   public:
      entity_data_set(const std::string& model,
                      const std::string& entityType,
                      const std::string& filter,
                      session const& sess,
                      const std::string& url);

      entity_data_set(const std::string& model,
                      const std::string& entityType,
                      const std::string& filter);

      explicit entity_data_set(saga::object const& o);

      ~entity_data_set(){}

      std::vector<saga::isn::entity_data> get_data() const;

      saga::isn::entity_data_set
         get_related_entities(const std::string& relatedName,
                              const std::string& filter = std::string()) const;

      std::vector<std::string>
         list_related_entity_names() const;

      std::string get_information_system_url() const;

      unsigned int get_entity_count() const;
};

} //namespace isn
} //namespace saga
////////////////////////////////////////////////////////////////////////
#endif

