#ifndef _ENTITY_TYPES_HPP_
#define _ENTITY_TYPES_HPP_

#include <string>
#include <map>

typedef struct
{
   std::string adaptorName;
   bool multivalued;
   std::string type;
} ENTITY_ATTR_MAP_TYPE;

typedef struct
{
   std::string primaryKey;
   std::string secondaryKey;
   bool reverseLookup;
   bool directLookup;
   std::string entityLdapName;
} ENTITY_RELATIONSHIP_TYPE;

typedef struct
{
   std::string adaptorName;
   std::map<std::string, ENTITY_ATTR_MAP_TYPE> attrs;
   std::multimap<std::string, ENTITY_RELATIONSHIP_TYPE> relatedEntities;
} ENTITY_ATTR_TYPE;

#endif

