#  Copyright (c) 2005-2007 Andre Merzky (andre@merzky.net)
#
#  Distributed under the Boost Software License, Version 1.0. (See accompanying
#  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

ifndef SAGA_MK_INC_CONF_BOOST
       SAGA_MK_INC_CONF_BOOST = yes


###########################################################
#
# Boost
#
SAGA_HAVE_BOOST                 = yes
SAGA_BOOST_LOCATION             = /usr
SAGA_BOOST_HAVE_ASIO            = no
SAGA_BOOST_HAVE_TEST            = yes
SAGA_BOOST_HAVE_SYSTEM          = no
SAGA_BOOST_HAVE_IOSTREAMS       = yes
SAGA_BOOST_HAVE_PROGRAM_OPTIONS = yes

SAGA_BOOST_VERSION_MAJ          = 1
SAGA_BOOST_VERSION_MIN          = 33
SAGA_BOOST_VERSION_SUB          = 1

# always add our local boost include paths, before the system boost installation
ifdef SAGA_ROOT

  BOOST_EXT_DIRS           = futures plugin process spirit uuid serialization

  ifneq "x$(SAGA_BOOST_HAVE_ASIO)" "xyes"
    BOOST_EXT_DIRS        += asio
  endif

  ifneq "x$(SAGA_BOOST_HAVE_IOSTREAMS)" "xyes"
    BOOST_EXT_DIRS        += iostreams
    SAGA_LDFLAGS_EXT      += -L$(SAGA_ROOT)/external/boost/iostreams/boost/libs/iostreams/src/ -lboost_iostreams
  endif

  # add libboost_system, but only if SAGA_ROOT is defined, i.e. if we link in the
  # source tree.
  ifneq "x$(SAGA_BOOST_HAVE_SYSTEM)" "xyes"
    BOOST_EXT_DIRS        += system
    SAGA_LDFLAGS_EXT      += -L$(SAGA_ROOT)/external/boost/system/libs/system/src -lboost_system
  endif

  BOOST_EXT_INCLUDES       = $(foreach dir,$(BOOST_EXT_DIRS),-I$(SAGA_ROOT)/external/boost/$(dir))
  SAGA_CPPINCS            += $(BOOST_EXT_INCLUDES)

endif



ifeq "x$(SAGA_HAVE_BOOST)" "xyes"
  SAGA_BOOST_INC_FLAGS    += -I/usr/include/ -pthread
  SAGA_BOOST_LDFLAGS      += -L/usr/lib  -lboost_thread -pthread -lboost_filesystem -lboost_regex -lboost_serialization -lboost_iostreams
  SAGA_BOOST_S_LIBS       +=  /usr/lib/libboost_thread.a /usr/lib/libboost_filesystem.a /usr/lib/libboost_regex.a /usr/lib/libboost_serialization.a /usr/lib/libboost_iostreams.a

  SAGA_CPPINCS_SYS        += $(SAGA_BOOST_INC_FLAGS)
  SAGA_LDFLAGS_SYS        += $(SAGA_BOOST_LDFLAGS)
  SAGA_S_LIBS             += $(SAGA_BOOST_S_LIBS)
endif


SAGA_BOOST_TEST_LDFLAGS    = -lboost_unit_test_framework
SAGA_BOOST_OPTIONS_LDFLAGS = -lboost_program_options
#
###########################################################

endif # guard

